/*
  Soler jean-michel
         (droits rservs).
         Ce fichier est destin  illustrer l'article sur la couleur
         du reporter 3.
         indispensable pour ralis RGBLUMEN.POV/pcx qui se trouve dans
         le rep 6.
*/

#include "colors.inc"
#include "shapes.inc"

#declare hauteur=1.0


#declare encre_bleu =  color red 0.1 green 0.4 blue 0.8
#declare encre_violet =  color red 0.5 green 0.1 blue 0.75
#declare encre_violet_clair =  color red 0.57 green 0.17 blue 0.77
#declare encre_roset =  color red 0.99 green 0.19 blue 0.08

#declare blanc_transparent = color red 1.0 green 1.0 blue 1.0 filter 1.0

#declare blanc_papier =color red 0.989 green 0.989 blue 0.968

/*
       Dgrad de couleurs primaires en cercle.
       rayonnant  partir du centre d'un disque,
       application du parametre "radial" dans le champ
       "pigment" de pov 2.01.

       note : la dclaration des couleurs intermdiaires : Cyan,Magenta et
       Yellow est bien meilleure qu'une  table ne contenant que le rouge
       le bleu et le vert.
*/

#declare t0 =
texture{
        pigment
                {
                radial
                color_map
                        {
                        [0.0, 0.333/2
                                color   Yellow    //  color red 1.0 green 1.0 blue 0.0
                                color   Red    //  color red 1.0 green 0.0 blue 1.0
                                ]

                        [0.333/2,0.333
                                color   Red    //  color red 1.0 green 1.0 blue 0.0
                                color   Magenta    //  color red 1.0 green 0.0 blue 1.0
                                ]

                        [0.333,0.333+0.333/2
                                color Magenta   //red 1.0 green 0.0 blue 1.0
                                color Blue      //red 0.0 green 1.0 blue 1.0
                                ]

                        [0.333+0.333/2,0.666
                                color Blue   //red 1.0 green 0.0 blue 1.0
                                color Cyan      //red 0.0 green 1.0 blue 1.0
                                ]

                        [0.666,0.666+0.333/2
                                color Cyan      //red 0.0 green 1.0 blue 1.0
                                color Green     //red 1.0 green 1.0 blue 0.0
                                ]
                        [0.666+0.33/2,1.00
                                color Green       //red 0.0 green 1.0 blue 1.0
                                color Yellow     //red 1.0 green 1.0 blue 0.0
                                ]
                        }
                }
        }

/*
       Dgrad de couleurs primaires en cercle.
       partie inferieure du rombode dgrad en hauteur
       vers le noir : doit etre bascul et prsente  l'envers,
       pour s'ajuster au cone suprieur sans rupture gnante
       les couleurs sont "symtriques" suivant une ligne
       tangente au disque  la texture t0.
*/

#declare t0_p =
texture{
        pigment
                {
                radial
                color_map
                        {
                        [0.0, 0.333/2
                                color  Yellow    //  color red 1.0 green 1.0 blue 0.0
                                color  Green     //  color red 1.0 green 0.0 blue 1.0
                                ]

                        [0.333/2, 0.333
                                color  Green     //  color red 1.0 green 1.0 blue 0.0
                                color  Cyan      //  color red 1.0 green 0.0 blue 1.0
                                ]

                        [0.333,0.333/2+0.333
                                color Cyan       //   red 1.0 green 0.0 blue 1.0
                                color Blue       //   red 0.0 green 1.0 blue 1.0
                                ]

                        [0.333+0.333/2,0.666
                                color Blue       //   red 1.0 green 0.0 blue 1.0
                                color Magenta    //   red 0.0 green 1.0 blue 1.0
                                ]

                        [0.666,0.666+0.333/2
                                color Magenta    //   red 0.0 green 1.0 blue 1.0
                                color Red        //   red 1.0 green 1.0 blue 0.0
                                ]

                        [0.666+0.333/2,1.00
                                color Red        //   red 0.0 green 1.0 blue 1.0
                                color Yellow     //   red 1.0 green 1.0 blue 0.0
                                ]
                        }
                }
        }

/*
        Dgrade de couleurs  en sphre:
        au coeur du modle le mlange devrait tre noir
*/

#declare t1=
texture{ pigment {
                onion
                color_map
                        {
                        [0.0,  1.0
                                 color red 0.0 green 0.0 blue 0.0 filter 0.0
                                 color red 1.0 green 1.0 blue 1.0 filter 1.0
                                 ]
                                 }
                        }

     translate<0, 0, 0>
    scale<1 1 1>
    }


/*
Dgrad vers le blanc orient vers le haut: Y
*/

#declare t2=
texture{
        pigment {
                gradient y
                color_map
                        {
                        [0.0, 0.75
                                color red 0.0 green 0.0 blue 0.0 filter 1.0
                                color red 1.0 green 1.0 blue 1.0 filter 0.0
                                   ]
                        [0.75, 1.0
                                color red 1.0 green 1.0 blue 1.0 filter 0.0
                                color red 1.0 green 1.0 blue 1.0 filter 0.0
                                ]
                        }
                 }
        scale<1 hauteur 1>
        translate<0  hauteur 0>
        }
/*
Dgrad vers le noir orient vers le haut: Y
*/
#declare t3=
texture{ pigment {
                gradient y
                color_map
                        {
                        [0.0,0.75
                                color blanc_transparent
//                              color red 1.0 green 1.0 blue 1.0 filter 1.0
                                color red 0.0 green 0.0 blue 0.0 filter 0.0
                                ]
                          [0.75,1.0
                                color red 0.0 green 0.0 blue 0.0 filter 0.0
                                color red 0.0 green 0.0 blue 0.0 filter 0.0
                                ]
                        }
                }
    scale<1 hauteur 1>
    translate<0 hauteur 0>
    }

/*
Texture du plan de coupe
*/
#declare t4=
texture{
             pigment {
                gradient x
                color_map
                        {
                        [0.0,1.0
                                color red 1.0 green 1.0 blue 0.0 filter 0.0
                                color red 0.0 green 0.0 blue 1.0 filter 0.0
                                ]
                        }
                }
   // scale<1 hauteur 1>
    translate< hauteur 0 0>
    }

#declare ligne_vert=
               texture{
                pigment {
                        gradient x
                        color_map
                            {
/*ligne bleu paisse */       [0.0,0.1/16
                                    color encre_violet_clair
                                    color encre_violet_clair
                                    ]

/* espace blanc */            [0.1/16,1.0-0.1/16
                                   color  blanc_transparent
                                   color blanc_transparent
//                                    color red 1.0 green 1.0 blue 1.0 filter 1.0
//                                    color red 1.0 green 1.0 blue 1.0 filter 1.0
                                    ]
/*ligne violet 1         */     [1.0-1/16,1.0
                                    color encre_violet
                                    color encre_violet
                                    ]
                                }
                           }
                       }



#declare ligne_horz=
               texture{
                pigment {
                        gradient z
                        color_map
                            {
/*ligne bleu paisse */       [0.0,0.1/16
                                    color encre_violet
                                    color encre_violet
                                    ]

/* espace blanc */            [0.1/16,1/4-0.1/16
                                   color blanc_papier
                                   color blanc_papier
                                    ]
/*ligne bleu 1  1/4     */     [1/4-0.1/16,1/4
                                    color encre_bleu
                                    color encre_bleu
                                    ]
/* espace blanc */             [1/4,1/2-0.1/16
                                   color blanc_papier
                                   color blanc_papier
                                    ]
/*ligne bleu 2   1/2    */     [1/2-0.1/16,1/2
                                    color encre_bleu
                                    color encre_bleu
                                    ]
/* espace blanc */             [1/2,3/4-0.1/16
                                   color blanc_papier
                                   color blanc_papier
                                    ]
/*ligne bleu 3   3/4    */     [3/4-0.1/16,3/4
                                    color encre_bleu
                                    color encre_bleu
                                    ]
/* espace blanc */             [3/4,1.0-0.1/16
                                   color blanc_papier
                                   color blanc_papier
                                    ]
/*ligne bleu 3   3/4    */     [1.0-0.1/16,1.0
                                    color encre_violet
                                    color encre_violet
                                    ]

                                }
                          }
//             finish{specular 1.0 roughness 0.7 }
                      }

